<%@ Control Language="c#" Codebehind="TokenSecurity.ascx.cs" AutoEventWireup="True"
	Inherits="DataIllusion.FeedbackServer.WebAdmin.TokenSecurity" %>
<%@ Import Namespace="DataIllusion.FeedbackServer.WebAdmin" %>
<%@ Register Assembly="DataIllusion.FeedbackServer.AjaxControlToolkit" Namespace="DataIllusion.FeedbackServer.AjaxControlToolkit" TagPrefix="ajaxToolkit" %> 
<%@ Register Src="../UserControls/DynamicGridView.ascx" TagName="DynamicGridView" TagPrefix="uc1" %>

<script type="text/javascript">

	function loadTab(sender, args)
	{
		initTab(sender, args);
	}
	
	function initTab(sender, args)
	{
		resizeContainer(sender, null);
	}

	function resizeContainer(sender, args)
	{
		if (!sender)
			return;

		var panelBody = $get('<%=TokenTabs.ClientID%>_body'),
			answerTab = $get(sender.get_tabs()[sender.get_activeTabIndex()].get_id()),
			scrollHeight = answerTab.scrollHeight,
			scrollWidth = answerTab.scrollWidth;

		if (scrollHeight < 250)
		{
			panelBody.style.height = "250px";
		}
		else
		{
			panelBody.style.height = scrollHeight + "px";
		}
	}

	function viewDetails(rowId, rowIndex)
	{
		var windowName = 'pi' +rowId;
		
		var winHandle = window.open('tokendetails.aspx?surveyid=<%=SurveyId%>&tokenid='+rowId, windowName,'height=690,width=910,scrollbars=1,titlebar=0,resizable=1');
		if (winHandle != null)
		{
			winHandle.focus();
		}
	}
	
	function deleteUsedEntries()
	{
		if(confirm('<%=GetPageResource("DeleteAvailableTokenConfirmationMessage")%>')== false) return false;
		DataIllusion.FeedbackServer.Services.Web.Admin.SurveysService.DeleteSurveyTokens(<%=SurveyId%>, 
			GetSelectedIds<%=UsedTokenDynamicGridView.ClientID%>(), deleteUsedEntries_callback);
	}

	function deletePendingEntries()
	{
		if(confirm('<%=GetPageResource("DeleteAvailableTokenConfirmationMessage")%>')== false) return false;
		DataIllusion.FeedbackServer.Services.Web.Admin.SurveysService.DeleteSurveyTokens(<%=SurveyId%>, 
			GetSelectedIds<%=PendingTokenDynamicGridView.ClientID%>(), deletePendingEntries_callback);
	}
	
	function deleteAllUsedTokens()
	{
		if(confirm('<%=GetPageResource("DeleteAllUsedTokenConfirmationMessage")%>')== false) return false;
		DataIllusion.FeedbackServer.Services.Web.Admin.SurveysService.DeleteUsedTokens(<%=SurveyId%>, deleteUsedEntries_callback);
		return false;
	}

	function deleteAllAvailableTokens()
	{
		if(confirm('<%=GetPageResource("DeleteAllAvailableTokenConfirmationMessage")%>')== false) return false;
		DataIllusion.FeedbackServer.Services.Web.Admin.SurveysService.DeleteAvailableTokens(<%=SurveyId%>, deletePendingEntries_callback);
		return false;
	}

	function deleteUsedEntries_callback(res) 
	{
		ReloadGrid<%=UsedTokenDynamicGridView.ClientID%>()
	}

	function deletePendingEntries_callback(res) 
	{
		ReloadGrid<%=PendingTokenDynamicGridView.ClientID%>()
	}
		
</script>

<table class="adminTitle">
	<tr>
		<td>
			<a href="help/FeedbackServer.htm#Security/Security_tokens.htm" target="feedbackserverhelp">
				<img src="images/helpicon.gif" border="0"></a></td>
		<td width="99%">
			<asp:Literal ID="TokenSecurityTitle" runat="server" Text="Used tokens - Page" EnableViewState="False"></asp:Literal></td>
	</tr>
</table>


<table width="95%">
	<tr>
		<td>
			&nbsp;&nbsp;
		</td>
		<td valign="top">
			<ajaxToolkit:TabContainer runat="server" ID="TokenTabs" ActiveTabIndex="0" Height="280px"
				Width="100%" OnClientTabLoaded="loadTab" OnClientActiveTabChanged="initTab">
				<ajaxToolkit:TabPanel CssClass="TabStyle" runat="server" ID="UsedTabPanel" HeaderText="Sent">
					<ContentTemplate>
						<table>
							<tr>
								<td style="font-size: 0.7em">
									<uc1:DynamicGridView ID="UsedTokenDynamicGridView" runat="server" />
									<input type="button" id="Button1" value="<%=GetPageResource("DeleteUsedButton")%>" onClick="deleteUsedEntries()"/>
									<input type="button" id="DeleteUsedTokensButton" runat="server"  onclick="deleteAllUsedTokens()"/>
									<asp:Button ID="ExportUsedButton" Text="" OnClick="ExportUsedButton_Click" runat="server" /></asp:Button>
								</td>
							</tr>
						</table>
					</ContentTemplate>
				</ajaxToolkit:TabPanel>
				<ajaxToolkit:TabPanel CssClass="TabStyle" runat="server" ID="PendingTabPanel" HeaderText="Queue">
					<ContentTemplate>
						<table>
							<tr>
								<td style="font-size: 0.7em">
									<uc1:DynamicGridView ID="PendingTokenDynamicGridView" runat="server" />
									<input type="button" id="DeletePendingEntries" value="<%=GetPageResource("DeleteUsedButton")%>" onClick="deletePendingEntries()"/>
									<input type="button" id="DeleteAvailableTokensButton" runat="server" onclick="deleteAllAvailableTokens()"/>
									<asp:Button ID="ExportAvailableTokens" OnClick="ExportAvailableButton_Click" Text="" runat="server" /></asp:Button>
								</td>
							</tr>
						</table>
					</ContentTemplate>
				</ajaxToolkit:TabPanel>
				<ajaxToolkit:TabPanel CssClass="TabStyle" runat="server" ID="CreationTabPanel" HeaderText="Queue">
					<ContentTemplate>
						<asp:UpdatePanel ID="PageUpdatePanel" UpdateMode="Conditional" runat="server">
							<Triggers><asp:AsyncPostBackTrigger ControlID="GenerateTokenRadio" />
							<asp:PostBackTrigger ControlID="ImportTokensButton" />
							</Triggers>

							<ContentTemplate>
<asp:Label ID="TokenGenerationMessageLabel" runat="server" ForeColor="Green" Visible="False"></asp:Label>
<table class="settingsTable">
	<tr>
		<td width="99%">
											<table>
												<tr>
													<td nowrap class="labelStyle">
														<asp:Literal ID="GenerateTokenFromLabel" runat="server" EnableViewState="False"></asp:Literal>
													</td>
													<td>
														<asp:RadioButtonList RepeatDirection="Horizontal" ID="GenerateTokenRadio" OnSelectedIndexChanged="GenerateTokenRadio_IndexChanged" AutoPostBack="true" runat="server" />
													</td>
												</tr>
											</table>
											
								<asp:PlaceHolder ID="TokenGeneratorPlaceHolder" runat="server">
											<table>
												<tr>
													<td valign="top" nowrap class="labelStyle">
														<asp:Literal ID="TokenToGenerateLabel" runat="server" Text="Number of tokens to generate :"
															EnableViewState="False"></asp:Literal>
													</td>
													<td width="99%">
														<asp:TextBox ID="TokenNumberTextBox" runat="server" Columns="4"></asp:TextBox>
													</td>
												</tr>
												<tr>
													<td valign="top" nowrap class="labelStyle" height="11">
														<asp:Literal ID="TokeTypeLabel" runat="server" Text="Type of token :" EnableViewState="False"></asp:Literal>
													</td>
													<td height="11">
														<asp:DropDownList ID="TokenTypeDropDownList" runat="server" AutoPostBack="True" OnSelectedIndexChanged="TokenTypeDropDownList_SelectedIndexChanged">
														</asp:DropDownList>
													</td>
												</tr>
												<tr>
													<td valign="top" nowrap class="labelStyle">
														<asp:Literal ID="TokenLengthLabel" runat="server" Visible="False" Text="Token length:"></asp:Literal>
													</td>
													<td>
														<asp:DropDownList ID="TokenLengthDropDownList" runat="server" Visible="False">
															<asp:ListItem Value="6">6</asp:ListItem>
															<asp:ListItem Value="7">7</asp:ListItem>
															<asp:ListItem Value="8">8</asp:ListItem>
															<asp:ListItem Value="9">9</asp:ListItem>
															<asp:ListItem Value="10">10</asp:ListItem>
															<asp:ListItem Value="11">11</asp:ListItem>
															<asp:ListItem Value="12">12</asp:ListItem>
															<asp:ListItem Value="13">13</asp:ListItem>
															<asp:ListItem Value="14">14</asp:ListItem>
															<asp:ListItem Value="15">15</asp:ListItem>
															<asp:ListItem Value="16">16</asp:ListItem>
														</asp:DropDownList>
													</td>
												</tr>
											</table>
											<asp:Button ID="GenerateTokensButton" runat="server" Text="Generate tokens" OnClick="GenerateTokensButton_Click">
											</asp:Button>
											
								</asp:PlaceHolder>
								<asp:PlaceHolder ID="SingleTokenPlaceHolder" runat="server">

											<table>
												<tr>
													<td valign="top" nowrap class="labelStyle">
														<asp:Literal ID="TokenValueLabel" runat="server" Text="Token value :" EnableViewState="False"></asp:Literal>
													</td>
													<td width="99%">
														<asp:TextBox ID="TokenValueTextbox" runat="server"></asp:TextBox>
													</td>
												</tr>
												<tr>
													<td valign="top" nowrap class="labelStyle">
														<asp:Literal ID="FirstNameLabel" runat="server" Text="First name :" EnableViewState="False"></asp:Literal>
													</td>
													<td>
														<asp:TextBox ID="FirstNameTextbox" runat="server"></asp:TextBox>
													</td>
												</tr>
												<tr>
													<td valign="top" nowrap class="labelStyle" height="27">
														<asp:Literal ID="LastNameLabel" runat="server" Text="Last name :" EnableViewState="False"></asp:Literal>
													</td>
													<td height="27">
														<asp:TextBox ID="LastNameTextbox" runat="server"></asp:TextBox>
													</td>
												</tr>
												<tr>
													<td valign="top" nowrap class="labelStyle">
														<asp:Literal ID="EmailLabel" runat="server" Text="Email :" EnableViewState="False"></asp:Literal>
													</td>
													<td>
														<asp:TextBox ID="EmailTextbox" runat="server"></asp:TextBox>
													</td>
												</tr>
											</table>
											<asp:Button ID="AddNewTokenButton" runat="server" Text="Add new token" OnClick="AddNewTokenButton_Click">
											</asp:Button>
								</asp:PlaceHolder>

						<asp:PlaceHolder ID="UploadTokenPlaceHolder" runat="server">
									<table>
										<tr>
											<td valign="top" nowrap class="labelStyle">
												<asp:Literal ID="TokenCSVFileLabel" runat="server" Text="CSV File :"></asp:Literal>
											</td>
											<td width="99%" class="smallText">
												<input id="ImportFile" type="file" name="ImportFile" runat="server"><br>
												<asp:Label ID="ImportTokenInfo1Label" runat="server" EnableViewState="False"> Import format are comma separated values, each new line must contain a token to import eg :</asp:Label><br>
												<asp:Label ID="ImportTokenInfo2Label" runat="server" EnableViewState="False"> TokenValue,First name,Last name,Email </asp:Label><br>
												<asp:Label ID="ImportTokenInfo3Label" runat="server" EnableViewState="False">or<br> TokenValue,,, </asp:Label>
											</td>
										</tr>
									</table>
									<asp:Button ID="ImportTokensButton" runat="server" Text="Import tokens" OnClick="ImportTokensButton_Click">
									</asp:Button>
						</asp:PlaceHolder>
</td></tr></table>
						
								</ContentTemplate>
						</asp:UpdatePanel>

					</ContentTemplate>
				</ajaxToolkit:TabPanel>

			</ajaxToolkit:TabContainer>
		</td>
	</tr>
</table>
<script type="text/javascript">
	if (Sys && Sys.WebForms && Sys.WebForms.PageRequestManager) {
		var prm = Sys.WebForms.PageRequestManager.getInstance();
		if (!prm.get_isInAsyncPostBack()) {
			prm.add_endRequest(endDialogRequest);
			prm.add_beginRequest(BeginRequestHandler);
		}
	}

	function BeginRequestHandler(sender, args)
	{
		indicateStartProcess();
	}

	function endDialogRequest(sender, e)
	{
		indicateEndProcess();
	}
</script>