/*
Copyright (c) 2011 Data Illusion Zumbrunn (http://www.dataillusion.com). All rights reserved.
Redistributions of source code must retain the above copyright notice and is licensed under 
the FeedbackServer End User License Agreement version provided with this package
 
*/
function fitIFrame(id)
{
    var iFrame = parent.document.getElementById(id)
	if (iFrame && iFrame.contentDocument && iFrame.contentDocument.height) // firefox 
    { 
        // Firefox doesnt paint content of iframes of height bigger than 32768
        if (document.body.scrollHeight >= 32768)
        {
            // Activate autoscroll feature in that case
            iFrame.style.height = "768px";
            iFrame.scrolling = "yes";
            iFrame.style.width = this.document.body.scrollWidth+20+"px";
            iFrame.style.display="block"
        }
        else
        {
            iFrame.scrolling = "no";
            iFrame.style.height = document.body.scrollHeight+ "px"; 
        }
    }
    else if (iFrame)
    {
	    if (this.document.body.scrollHeight < 600)
	    {
		    iFrame.style.height="600px";
	    }
	    else
	    {
		    iFrame.style.height=document.body.clientHeight;//this.document.body.scrollHeight + "px";
	    }

	}

    if (iFrame)
    {
		iFrame.style.width = "100%";
		iFrame.style.display="block"
    }
}


function fitDiv(id, frameId)
{
    var iFrame = parent.document.getElementById(frameId),
		iDiv = parent.document.getElementById(id);

	iDiv.style.width = iFrame.style.width  + "px";
	iDiv.style.height = (parseInt(iFrame.style.height) + 30) + "px";  
}

function indicateStartProcess()
{
	if (!statusDialogShow) 
	{
		showStatusDialog('Processing request, please wait ...');
	}
}

function indicateEndProcess()
{
	hideStatusDialog();
}

var fsStatusContainer,
	statusDialog,
	statusDialogShow = false,
	errorStatus;

function showStatusDialog(statusText) 
{

	// RTL is currently not supported for dialog status window
	if (fsLanguageDirection && fsLanguageDirection == 'rtl')
	{
		return;
	}

	if (errorStatus)
	{
		errorStatus = null;
		return;
	}


	if (statusDialog != undefined && statusDialog)
	{
		statusDialog.show();
		return;
	}

	statusDialog =
        new YAHOO.widget.Panel("waitdialog",
              { width: "240px",
              fixedcenter: true,
              close: false,
              draggable: false,
              zindex: 4,
              modal: true,
              visible: false
              }
		);

	statusDialog.setHeader(statusText);
	statusDialog.setBody("<img src=\"images/activity.gif\"/>");
	statusDialog.render(document.body);

	// Show the Panel
	statusDialog.show();
	statusDialogShow = true;
}

function hideStatusDialog() 
{
	if (statusDialog != undefined && statusDialog)
	{
		statusDialog.hide();
		statusDialogShow = false;
	}
}

function registerTreeUnload()
{
	window.onunload = unload;
	window.onbeforeunload = fixUnload; 
}

function registerAdminUnload()
{
	window.onunload = adminUnload;
	window.onbeforeunload = fixAdminUnload; 
}


function unload() 
{
	if (YAHOO.util.DivDragDropMgr)
	{
		 YAHOO.util.DivDragDropMgr.unregAllFrame('fsMenu');
    }
}

function fixUnload() 
{
    // Is there are things still loading, then fake the unload event
    if (document.readyState == 'interactive' && document.attachEvent) {
		
            function stop() {
                    // Prevent memory leak
                    document.detachEvent('onstop', stop);

                    // Call unload handler
                    unload();
            };

            // Fire unload when the currently loading page is stopped
            document.attachEvent('onstop', stop);

            // Remove onstop listener after a while to prevent the unload function
            // to execute if the user presses cancel in an onbeforeunload
            // confirm dialog and then presses the stop button in the browser
            window.setTimeout(function() {
                    document.detachEvent('onstop', stop);
            }, 0);
    }
    
}

function adminUnload() 
{
	if (YAHOO.util.DivDragDropMgr && parent && typeof(parent.clearReg)=="function" && parent.clearReg())
	{
		YAHOO.util.DivDragDropMgr.unregAllFrame('fsadmin');
	}
}

function fixAdminUnload() 
{
    // Is there are things still loading, then fake the unload event
    if (document.readyState == 'interactive' && document.attachEvent) {
		
            function stop() {
                    // Prevent memory leak
                    document.detachEvent('onstop', stop);

                    // Call unload handler
                    adminUnload();
            };

            // Fire unload when the currently loading page is stopped
            document.attachEvent('onstop', stop);

            // Remove onstop listener after a while to prevent the unload function
            // to execute if the user presses cancel in an onbeforeunload
            // confirm dialog and then presses the stop button in the browser
            window.setTimeout(function() {
                    document.detachEvent('onstop', stop);
            }, 0);
    }
}


function insertText(fieldElement, fieldValue)
{
	if (document.selection) {
		fieldElement.focus();
		sel = document.selection.createRange();
		sel.text = fieldValue;
	}
	else if (fieldElement.selectionStart || fieldElement.selectionStart == '0') {
		var startPos = fieldElement.selectionStart;
		var endPos = fieldElement.selectionEnd;
		fieldElement.value = fieldElement.value.substring(0, startPos)
			+ fieldValue
			+ fieldElement.value.substring(endPos, fieldElement.value.length);
	} else {
		fieldElement.value += fieldValue;
	}
}
